<cfscript>
    obj = createObject("component", "Artists");
</cfscript>


<cfif isDefined("form.delete")>
    <cfscript>
        obj.deleteArtist(artistID=form.artistID);
    </cfscript>
</cfif>


<cfset getArtistDetails = obj.getArtists()>
<strong>Delete an Artist from the Database</strong>

<cfoutput query="getArtistDetails">
<cfform>
    <input type="hidden" name="artistID" value="#getArtistDetails.artistID#">
    <table cellpadding="5" cellspacing="0" border="0">
    <tr>
        <td align="right">
            <strong>First Name:</strong>
        </td>
        <td>
            #getArtistDetails.firstName#
        </td>
    </tr>
    <tr>
        <td align="right">
            <strong>Last Name:</strong>
        </td>
        <td>
            #getArtistDetails.lastName#
        </td>
    </tr>
    <tr>
        <td align="right">
            <strong>Phone:</strong>
        </td>
        <td>
            #getArtistDetails.phone#
        </td>
    </tr>
    <tr>
        <td align="right"> </td>
        <td>
            <input type="submit" name="delete" value="Delete">
        </td>
    </tr>
    </table>
</cfform>
</cfoutput>

 
<!---
--------------------------------------------------------------------------------
 
The getArtist method of the Artists.cfc is invoked to return all the artists from the database listed in alphabetical order.

The results are then displayed in a table that contains an extra column for the edit and delete links. The delete link points to the delete.cfm page and creates one URL variable, artistID, to allow the delete.cfm page to determine which user should be deleted. 

Above the table there is a conditional statement that checks for a url.delete variable. This variable will not exist when the user first views the list page, but the delete action will redirect the user back to this page and pass along this variable, which will trigger the display of the message.

This is a demo example. Records are not actually deleted from the database. 
--->


<!--- Add the following code to a file called artists.cfc 
<br><br>
<cfcomponent>
    <cffunction access="public" name="getArtists" output="false" returntype="query">
        <cfset var artistsQuery="">
        <cfquery name="artistsQuery" datasource="#request.dsn#">
            SELECT ARTISTID, FIRSTNAME, LASTNAME, PHONE
            FROM GSTARTED.ARTISTS
            ORDER BY LASTNAME
        </cfquery>
        <cfreturn artistsQuery />
    </cffunction>
    
    
    <cffunction access="public" name="insertArtist" output="false" returntype="boolean">
        <cfargument name="formVariables" type="struct" required="yes">
        <cfset isSuccessful=true>
        <cftry>
            <cfquery name="artistsInsert" datasource="#request.dsn#">
                INSERT INTO ARTISTS (FIRSTNAME, LASTNAME, PHONE)
                VALUES (
                    <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.firstName#">
                    , <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.lastName#">
                    , <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.phone#">)
            </cfquery>
            <cfcatch type="Database"><cfset isSuccessful=false></cfcatch>
        </cftry>
        <cfreturn isSuccessful>
    </cffunction>
    
    
    <cffunction access="public" name="updateArtist" output="false" returntype="boolean">
        <cfargument name="formVariables" type="struct" required="yes">
        <cfset isSuccessful=true>
        <cftry>
            <cfquery name="artistUpdate" datasource="#request.dsn#">
                UPDATE ARTISTS
                SET FIRSTNAME = <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.firstName#">,
                LASTNAME = <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.lastName#">, 
                PHONE = <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.phone#">
                WHERE ARTISTID = <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.artistID#">
            </cfquery>
            <cfcatch type="Database"><cfset isSuccessful=false></cfcatch>
        </cftry>
        <cfreturn isSuccessful>
    </cffunction>
    
    
    <cffunction access="public" name="deleteArtist" output="false" returntype="boolean">
        <cfargument name="artistID" type="numeric" required="yes">        
        <cfset isSuccessful=true>
        <cftry>
            <cfquery name="artistDelete" datasource="#request.dsn#">
                DELETE FROM GSTARTED.ARTISTS
                WHERE ARTISTID = <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.artistID#">
            </cfquery>
            <cfcatch type="Database"><cfset isSuccessful=false></cfcatch>
        </cftry>
        <cfreturn isSuccessful>
    </cffunction>
    
</cfcomponent>
--->
 
<!---
--------------------------------------------------------------------------------
 
There are four functions in Artists.cfc. The first, getArtists, is called from the list.cfm page to retrieve the artists' information for diplay. This function is also called from the form.cfm page to retrieve the one artist's information to display in the form. The CFC can be used for both purposes because of the optional cfargument tag. If the argument, artistID, is passed in using the cfinvokeargument tag, then the query is constrained by a WHERE clause to limit the records returned to only the one artist's record.

The second function, insertArtists, is not used in this code snippet. See the "cfquery/insert" code snippet for an example of this function in action.

The third function, updateArtists, is not used in this code snippet. See the "cfquery/update" code snippet for an example of this function in action.

The fourth function, deleteArtist, requires the artistID variable to be passed in and then used in the SQL DELETE statement to delete the data in the database. Note the use of the WHERE clause to ensure that only that one artist's record is deleted. If you forget the WHERE clause, every record in that table will be deleted.
 
--->