<cfscript>
    obj = createObject("component", "Artists");
    getArtistsRet = obj.getArtists();
</cfscript>

<b>Artists by Last Name</b>

<table cellpadding="5" cellspacing="0" border="1">
<tr>
    <th>Last Name</th>
    <th>First Name</th>
    <th>Phone</th>
</tr>
<cfoutput query="getArtistsRet">
<tr>
    <td>#getArtistsRet.lastName#</td>
    <td>#getArtistsRet.firstName#</td>
    <td>#getArtistsRet.phone#</td>
</tr>
</cfoutput>
</table>
 
<!---
--------------------------------------------------------------------------------
 
cfinvoke calls the getArtist method of the Artist.cfc stored in the component path, CFIDE.gettingstarted.snippets.Artists. Periods are used instead of forward or backward slashes commonly used between directory names. The path also begins in the web server root. 

Once the query is returned from the getArtist method, the cfinvoke tag stores the variable returned in a new variable called getArtistsRet.

The GetArtistsRet variable is used to populate an HTML table. Note the cfoutput tag is placed around a table row and the query attribute of that tag tells ColdFusion to loop over the result set, generating one row for every row returned from the databsae.
--->

<!--- Add the following code to a file called artists.cfc
<cfcomponent>
    <cffunction access="public" name="getArtists" output="false" returntype="query">
        <cfset var artistsQuery="">
        <cfquery name="artistsQuery" datasource="#request.dsn#">
            SELECT ARTISTID, FIRSTNAME, LASTNAME, PHONE
            FROM GSTARTED.ARTISTS
            ORDER BY LASTNAME
        </cfquery>
        <cfreturn artistsQuery />
    </cffunction>


    <cffunction access="public" name="insertArtist" output="false" returntype="boolean">
        <cfargument name="formVariables" type="struct" required="yes">
        <cfset isSuccessful=true>
        <cftry>
            <cfquery name="artistsInsert" datasource="#request.dsn#">
                INSERT INTO ARTISTS (FIRSTNAME, LASTNAME, PHONE)
                VALUES (
                    <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.firstName#">
                    , <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.lastName#">
                    , <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.phone#">)
            </cfquery>
            <cfcatch type="Database"><cfset isSuccessful=false></cfcatch>
        </cftry>
        <cfreturn isSuccessful>
    </cffunction>


    <cffunction access="public" name="updateArtist" output="false" returntype="boolean">
        <cfargument name="formVariables" type="struct" required="yes">
        <cfset isSuccessful=true>
        <cftry>
            <cfquery name="artistUpdate" datasource="#request.dsn#">
                UPDATE ARTISTS
                SET FIRSTNAME = <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.firstName#">,
                LASTNAME = <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.lastName#">,
                PHONE = <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.phone#">
                WHERE ARTISTID = <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.artistID#">
            </cfquery>
            <cfcatch type="Database"><cfset isSuccessful=false></cfcatch>
        </cftry>
        <cfreturn isSuccessful>
    </cffunction>


    <cffunction access="public" name="deleteArtist" output="false" returntype="boolean">
        <cfargument name="artistID" type="numeric" required="yes">
        <cfset isSuccessful=true>
        <cftry>
            <cfquery name="artistDelete" datasource="#request.dsn#">
                DELETE FROM GSTARTED.ARTISTS
                WHERE ARTISTID = <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.artistID#">
            </cfquery>
            <cfcatch type="Database"><cfset isSuccessful=false></cfcatch>
        </cftry>
        <cfreturn isSuccessful>
    </cffunction>

</cfcomponent>
--->
 
<!---
--------------------------------------------------------------------------------
 
The Artist.cfc contains one method, getArtists(), that returns a query to the calling page.

The cfset statement initializes the artistsQuery variable, which will hold the query created on the next line.

The artistsQuery references the cfartgallery datasource registered with the ColdFusion MX 7 server.

The SQL SELECT statement selects the fields, or columns, that you want ot display. The FROM statement references the table to which the columns belong. The ORDER BY clause tells the database to alphabetize the results by the artists' last name.
 
--->