<cfif isDefined("form.update")>
    <cfscript>
        obj = createObject("component", "Artists");
        obj.updateArtist(form);
    </cfscript>

    <font color="#FF0000">
        <cfoutput>
        <br><br>
        #form.firstName# #form.lastName# has been updated in the database.
        </cfoutput>
    </font>
</cfif>


<cfif not isDefined("url.artistID")>

<cfscript>
    obj = createObject("component", "Artists");
    getArtistsRet = obj.getArtists();
</cfscript>

<h1>Artists by Last Name</h1>
<table cellpadding="5" cellspacing="0" border="1">
<tr>
    <th>Last Name</th>
    <th>First Name</th>
    <th>Phone</th>
    <th>Action</th>
</tr>
    <cfoutput query="getArtistsRet">
    <tr>
        <td>#getArtistsRet.lastName#</td>
        <td>#getArtistsRet.firstName#</td>
        <td>#getArtistsRet.phone#</td>
        <td>
            <a href="#cgi.script_name#?#cgi.query_string#&ArtistID=#getArtistsRet.artistID#">edit</a>
        </td>
    </tr>
    </cfoutput>
</table>

<cfelse>    
    
    <cfscript>
        obj = createObject("component", "Artists");
        getArtistDetails = obj.getArtists(ArtistID);
    </cfscript>
    
    <cfform action="index.cfm" format="XML" skin="blue" width="200" height="200">
        <cfinput type="hidden" name="artistID" value="#getArtistDetails.artistID#">
        <cfformgroup type="vertical">
            <cfformitem type="HTML">
                <strong>Update the Artist in the Database</strong>
            </cfformitem>
            <cfinput id="firstName" title="First Name" name="firstName" size="20" maxlength="20" type="text" label="First Name" required="yes" message="First name is required." value="#getArtistDetails.firstName#" />
            <cfinput id="lastName" title="Last Name" name="lastName" size="20" maxlength="20" type="text" label="Last Name" required="yes" message="Last name is required." value="#getArtistDetails.lastName#" />
            <cfinput id="phone" title="Phone" name="Phone" size="15" maxlength="15" type="text" label="Phone" required="yes" message="Phone is required." value="#getArtistDetails.phone#" />
            <cfinput id="submit" title="Update" name="update" value="Update" type="submit" style="margin-left:135px" />
        </cfformgroup>
    </cfform>
</cfif>
 
<!---
--------------------------------------------------------------------------------
 
This is a self-referencing form page. That means that both the form and the action are contained on the same page. A conditional cfif statement is placed around the action section at the top of the page to ensure that this code is not run unless the form is submitted. The cfif statement checks for the form.update submit button variable, which will only exist if the user has submitted the form.

The cfinvoke tag towards the middle of the page requests the getArtists function from the Artist.cfc. It also uses the cfinvokeargument to pass the URL variable from the list.cfm page to the function. This will prompt the function to constrain the data returned to that of the one artist selected.

The cfform tags, towards the bottom of the code, wrap the XML form that prompts the user to enter a first name, last name and phone. Notice that the submit button is named update and that the value attributes of each text field displays the data returned from the cfinvoke tag. Another important point is that a hidden variable that holds the artistID is embedded into the form to be passed to the form action.

The cfinvoke tag in the action section at the top of the page calls the updateArtist method of the Artist.cfc. This CFC updates the data in the database and returns a boolean value, which the cfinvoke tag has named isSuccessful.

Note that if isSuccessful is true, then an update message is outputted to the page. 
--->


<!--- Add the following code to a file called artists.cfc 
<cfcomponent>
    <cffunction access="public" name="getArtists" output="false" returntype="query">
        <cfargument name="artistID" required="No">
        <cfset var artistsQuery="">
        <cfquery name="artistsQuery" datasource="#request.dsn#">
            SELECT ARTISTID, FIRSTNAME, LASTNAME, PHONE
            FROM GSTARTED.ARTISTS
            <cfif isDefined("arguments.artistid")>
                where artistid = <cfqueryparam cfsqltype="CF_SQL_INTEGER" value="#arguments.artistid#">
            </cfif>
            ORDER BY LASTNAME
        </cfquery>
        <cfreturn artistsQuery />
    </cffunction>
    
    
    <cffunction access="public" name="insertArtist" output="false" returntype="boolean">
        <cfargument name="formVariables" type="struct" required="yes">
        <cfset isSuccessful=true>
        <cftry>
            <cfquery name="artistsInsert" datasource="#request.dsn#">
                INSERT INTO ARTISTS (FIRSTNAME, LASTNAME, PHONE)
                VALUES (
                    <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.firstName#">
                    , <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.lastName#">
                    , <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.phone#">)
            </cfquery>
            <cfcatch type="Database"><cfset isSuccessful=false></cfcatch>
        </cftry>
        <cfreturn isSuccessful>
    </cffunction>
    
    
    <cffunction access="public" name="updateArtist" output="false" returntype="boolean">
        <cfargument name="formVariables" type="struct" required="yes">
        <cfset isSuccessful=true>
        <cftry>
            <cfquery name="artistUpdate" datasource="#request.dsn#">
                UPDATE ARTISTS
                SET FIRSTNAME = <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.firstName#">,
                LASTNAME = <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.lastName#">, 
                PHONE = <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.phone#">
                WHERE ARTISTID = <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.formVariables.artistID#">
            </cfquery>
            <cfcatch type="Database"><cfset isSuccessful=false></cfcatch>
        </cftry>
        <cfreturn isSuccessful>
    </cffunction>
    
    
    <cffunction access="public" name="deleteArtist" output="false" returntype="boolean">
        <cfargument name="artistID" type="numeric" required="yes">        
        <cfset isSuccessful=true>
        <cftry>
            <cfquery name="artistDelete" datasource="#request.dsn#">
                DELETE FROM GSTARTED.ARTISTS
                WHERE ARTISTID = <cfqueryparam cfsqltype="CF_SQL_VARCHAR" value="#arguments.artistID#">
            </cfquery>
            <cfcatch type="Database"><cfset isSuccessful=false></cfcatch>
        </cftry>
        <cfreturn isSuccessful>
    </cffunction>
    
</cfcomponent>

--->
 
<!---
--------------------------------------------------------------------------------
 
There are three functions in Artists.cfc. The first, getArtists, is called from the list.cfm page to retrieve the artists' information for diplay. This function is also called from the form.cfm page to retrieve the one artist's information to display in the form. The CFC can be used for both purposes because of the optional cfargument tag. If the argument, artistID, is passed in using the cfinvokeargument tag, then the query is constrained by a WHERE clause to limit the records returned to only the one artist's record.

The second function, insertArtist, is not used in this code snippet. See the "cfquery/insert" code snippet for an example of this function in action.

The third function, updateArtist, requires the form variables to be passed in and then used in the SQL UPDATE statement to update the data in the database. Note the use of the WHERE clause to ensure that only that one artist's record is updated. If you forget the WHERE clause, every record in that table will be updated.
 
--->